//
//  N80View.swift
//  N80X
//
//  Created by hiroshi on 2021/08/20.
//

import Foundation

protocol DragAndDropViewDelegate {
    func dragAndDropView(_ view: N80View,
                         didDragImageFileURLs urls: [URL])
}
func shouldAllowDrag(_ draggingInfo: NSDraggingInfo) -> Bool {
    let pasteBoard = draggingInfo.draggingPasteboard
    if pasteBoard.canReadObject(forClasses: [NSURL.self], options: nil) {
        return true
    }
    return false
}

open class N80View : NSView {
    var delegate: DragAndDropViewDelegate?
    fileprivate var _nofify:NotificationCenter!
    let acceptableTypes: [NSPasteboard.PasteboardType] = [.fileURL, .string]

    override public init(frame: CGRect) {
        super.init(frame: frame)
        self.registerForDraggedTypes([NSPasteboard.PasteboardType.fileURL])
    }

    required public init(coder: NSCoder) {
        super.init(coder: coder)!
        self.registerForDraggedTypes([NSPasteboard.PasteboardType.fileURL])
    }
    open override func keyDown(with event: NSEvent) {
        super.keyDown(with: event)
    }
    open override func keyUp(with event: NSEvent) {
        super.keyUp(with: event)
    }
    open override var acceptsFirstResponder: Bool {
        return true
    }
    open override func becomeFirstResponder() -> Bool {
        return true
    }
    open override func resignFirstResponder() -> Bool {
        return true
    }
    open override func performKeyEquivalent(with event: NSEvent) -> Bool {
        return true
    }
    open override func draggingEntered(_ sender: NSDraggingInfo) -> NSDragOperation {
        return shouldAllowDrag(sender) ? [.copy] : []
    }
    override open func prepareForDragOperation(_ sender: any NSDraggingInfo) -> Bool {
        return shouldAllowDrag(sender)
    }
    open override func performDragOperation(_ sender: any NSDraggingInfo) -> Bool {
        let pasteBoard:NSPasteboard? = sender.draggingPasteboard
        
        if pasteBoard != nil {
            if let urls = pasteBoard!.readObjects(forClasses: [NSURL.self], options: nil) as? [URL] {
                for url in urls {
                    print(url)
                    // 何らかの処理
                    delegate?.dragAndDropView(self, didDragImageFileURLs: urls)
                }
                return true
            }
        }
        return true
    }
}
