//
//  n80config.h
//  N80X
//
//  Copyright (C) 1993-2024 Hiroshi Kanemoto.
//    Released under the MIT license
//    http://opensource.org/licenses/mit-license.php
//
//  Created by hiroshi on 2024/05/15.
//
#ifndef __N80CONFIG__
#define __N80CONFIG__
#import <GameController/GCKeyCodes.h>
#import "n80em.h"
#include <sys/ioctl.h>
#include "n80.h"
#include "PC-8001.h"
//---------------------------------------------------------------------------
//	declare structures
//---------------------------------------------------------------------------
typedef void* LPVOID;
//-----------------------------------------------------------------------------
//    Emulator Class
//-----------------------------------------------------------------------------
@class n80config_data;
@interface n80config : NSObject {
	@private
	n80em			*n80em;
	n80config_data	*data;
}

@property (nonatomic, assign, readonly, getter=getParam) n80config_data const *param;

-(id)initWithN80:(n80em*)n80em config:(n80config_data*)config;
-(void)enter_config;
-(void)leave_config;
-(bool)OnKeyDown:(BYTE)key code:(GCKeyCode)c;
-(void)OnKeyUp:(BYTE)key code:(GCKeyCode)c;
-(void)reflect_menu_state;
-(void)chooser:(int)slot;

@end

@interface n80config_data : NSObject {
	@public
	char	slot[3][64];
}
@property (assign) BOOL interlace;
@property (assign) BOOL hires_crt;
@property (assign) BOOL tenkeyless;
@property (assign) BOOL chiqlappe;
@property (assign) BOOL nowait;

-(id)init;
-(void)set_char:(char)c index:(int)index slot:(int)slot;
-(char)get_char:(int)index slot:(int)slot;
-(int)get_size:(int)slot;
@end

#endif//__N80CONFIG__
